package blink.display;
import blink.display.DisplayObject;

#if flash

typedef DisplayObjectContainer = flash.display.DisplayObjectContainer;

#else 

typedef DisplayObjs = Array<DisplayObject>;
import blink.events.Event;

class DisplayObjectContainer extends InteractiveObject
{
   var mObjs : DisplayObjs;
   public var numChildren(GetNumChildren,null):Int;

   public function new()
   {
      mObjs = new DisplayObjs();
      super();
   }

   public function Render()
   {
      if (!visible) return;

      for(i in 0...mObjs.length)
      {
         var obj = mObjs[i];
         if (obj.IsTransformed())
         {
            nme_push_view();
            obj.Transform();
            mObjs[i].Render();
            nme_pop_view();
         }
         else
            mObjs[i].Render();
      }
   }
   public function GetNumChildren() { return mObjs.length; }

   public function AsContainer() { return this; }
   public function Broadcast(inEvent:Event)
   {
      dispatchEvent(inEvent);
      for(i in 0...mObjs.length)
      {
         var obj = mObjs[i];
         obj.dispatchEvent(inEvent);
         var container = obj.AsContainer();
         if (container!=null)
            container.Broadcast(inEvent);
      }

   }

   public function removeChildAt(inI:Int)
   {
      mObjs[inI].SetParent(null);
      mObjs.splice(inI,1);
   }

   public function getChildByName(inName:String):DisplayObject
   {
      for(i in 0...mObjs.length)
         if (mObjs[i].name==inName)
            return mObjs[i];
      return null;
   }


   public function addChild(inObject:DisplayObject)
   {
      mObjs.push(inObject);
      inObject.SetParent(this);
   }

   static var nme_push_view = neko.Lib.load("nme","nme_push_view",0);
   static var nme_pop_view = neko.Lib.load("nme","nme_pop_view",0);

}

#end
