package blink.text;

#if flash

typedef TextField = flash.text.TextField;

#else 
import nme.Point;
import nme.TTF;
import nme.TextureRect;

class TextField extends blink.display.DisplayObject
{
   public var htmlText(GetHTMLText,SetHTMLText):String;
   public var textColor(GetTextColour,SetTextColour):Int;
   private var mHTMLText:String;
   private var mTextColour:Int;


   var mData:TextureRect;

   public function new()
   {
      super();
      mData = new TextureRect();
      mHTMLText = " ";
      mTextColour = 0x000000;
   }

   public function Render()
   {
      if (!visible) return;

      mData.Quad();
   }

   public function GetTextColour() { return mTextColour; }
   public function SetTextColour(inCol)
   {
      mTextColour = inCol;
      mData.SetText("Times",24,mTextColour,mHTMLText);
      return inCol;
   }


   public function GetHTMLText() { return mHTMLText; }

   static var strip_tag = ~/<(.*?)>(.*)<(.*?)>/;
   public function SetHTMLText(inHTMLText:String)
   {
      if (strip_tag.match(inHTMLText))
      {
         mHTMLText = strip_tag.matchedLeft() + strip_tag.matched(2) +
                     strip_tag.matchedRight();
      }
      else
         mHTMLText = inHTMLText;
      mData.SetText("Times",24,mTextColour,mHTMLText);
      return mHTMLText;
   }

}

#end
