package org.cove.ape ;

	import flash.events.Event;

	/**
	 * CollisionEvent objects are dispatched during a collision between two
	 * AbstractItem (Particle or Constraint) objects. You can retrieve the
	 * AbstractItem that has collided with the target object by using the
	 * <code>collidingItem</code> property.
	 */
	class CollisionEvent extends Event {
		public var collidingItem(get_collidingItem,set_collidingItem):AbstractItem;
		public function set_collidingItem(__dummy:AbstractItem)
		{
		return collidingItem;
		}


		/**
		 * Defines the value of the type property of a collide event object
		 */
		public static var COLLIDE:String = "collide";
		public static var FIRST_COLLIDE:String = "firstCollide";

		private var _collidingItem:AbstractItem;

		public function new(
				type:String,
				?_opt_bubbles:Null<Bool>,
				?_opt_cancelable:Null<Bool>,
				collidingItem:AbstractItem = null) {
			var bubbles:Bool = _opt_bubbles==null ? false : _opt_bubbles;
			var cancelable:Bool = _opt_cancelable==null ? false : _opt_cancelable;

			super(type, bubbles, cancelable);
			_collidingItem = collidingItem;
		}


		/**
		 * Returns the AbstractItem (either a Constraint or Particle) object that has
		 * collided with the target object
		 */
		public function get_collidingItem():AbstractItem {

			if (Std.is(_collidingItem,SpringConstraintParticle)) {
				var scp:SpringConstraintParticle = cast(_collidingItem,SpringConstraintParticle);
				return scp.parent;
			}
			return _collidingItem;
		}
	}


