/*
Copyright (c) 2006, 2007 Alec Cove

Std.is(Permission,hereby) granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Std.is(Software,furnished) to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*
TODO:
*/

package org.cove.ape ;

	/**
	 * A force represented by a 2D vector.
	 */
	class VectorForce implements IForce {
		public var vx(null,set_vx):Float;
		public var vy(null,set_vy):Float;
		public var useMass(null,set_useMass):Bool;


		private var fvx:Float;
		private var fvy:Float;

		private var value:Vector;
		private var scaleMass:Bool;


		public function new(useMass:Bool, vx:Float, vy:Float) {
			fvx = vx;
			fvy = vy;
			scaleMass = useMass;
			value = new Vector(vx, vy);
		}


		public function set_vx(x:Float) {
			fvx = x;
			value.x = x;
			return x;
		}


		public function set_vy(y:Float) {
			fvy = y;
			value.y = y;
			return y;
		}


		public function set_useMass(b:Bool) {
			scaleMass = b;
			return b;
		}


		public function getValue(invmass:Float):Vector {
			if (scaleMass) {
				value.setTo(fvx * invmass, fvy * invmass);
			}
			return value;
		}
	}

