package ui.containers;

import ui.core.Element;
import ui.core.MultiContainer;
import ui.core.Rectangle;

class StackLayout extends MultiContainer {
  public var direction : StackDirection;
  
  public function new(?direction : StackDirection) {
    super();
    this.direction = if(direction == null) Vertical else direction;
    extents = new Array();
  }
  
  public override function calculateBounds(e : Element) : Rectangle<Float> {
    var idx = getIndex(e);
    var f = e.fitSize();
    var r = bounds();
    var h, v;
    if(direction == Vertical) {
      h = boundedSide(e.hLayout, r.width, e.minSize.width, e.maxSize.width, f.width);
      v = unboundedSide(e.vLayout, e.minSize.height, e.maxSize.height, f.height);
      extents[idx] = v.t;
    } else {
      h = unboundedSide(e.hLayout, e.minSize.width, e.maxSize.width, f.width);
      v = boundedSide(e.vLayout, r.height, e.minSize.height, e.maxSize.height, f.height);
      extents[idx] = h.t;
    }
    var offset = 0.0;
    for(t in 0...idx)
      offset+=extents[t]+spacing;
    if(direction == Vertical)
      return { x : h.d, y : v.d+offset, width : h.l, height : v.l };
    else
      return { x : h.d+offset, y : v.d, width : h.l, height : v.l };
  }
  private var extents : Array<Float>;
}

enum StackDirection {
  Horizontal;
  Vertical;
}