package ui.core;

class Container extends Element { 
  public var spacing : Float;
  
  public function new() {
    super();
    vLayout = hLayout = Layout.Margins(0);
    spacing = 0.0;
  }
  
  public function calculateBounds(e : Element) : Rectangle<Float> {
    return throw "AbstractMethod";
  }
  
  private function restrict(v : Float, min : Float, max : Float) {
    return Math.max(min, Math.min(v, max));
  }
  
  private function boundedSide(layout : Layout, len:  Float, min : Float, max : Float, fit : Float) : { d : Float, l : Float, t : Float } {
    switch(layout) {
      case Margins(margin, marginafter):
        if(marginafter == null)
          marginafter = margin;
        var content = len-margin-marginafter;
        var l = restrict(content, min, max);
        var d, t;
        if(l==content) {
          d = margin;
          t = l+d+marginafter;
        } else {
          d = margin/(margin+marginafter)*(len-l);
          t = l+d+(marginafter/(margin+marginafter)*(len-l));
        }
        return { d : d, l : l, t : t };
      case Center(content):
        if(content == null)
          content = fit;
        content = restrict(content, min, max);
        return { d : (len-content)/2, l : content, t : Math.max(len, content) };
      case AnchorStart(margin, content):
        if(content == null)
          content = restrict(fit, min, max);
        return { d : margin, l : content, t : margin+content };
      case AnchorEnd(margin, content):
        if(content == null)
          content = restrict(fit, min, max);
        return { d : len-margin-content, l : content, t : margin+content };
      case Measures(margin, content, marginafter):
        if(content == null)
          content = fit;
        var r = margin+content+marginafter;
        var content = content/r*len;
        var l = restrict(content, min, max);
        var d, t;
        if(content == l) {
          d = margin/r*len;
          t = l+d+marginafter/r*len;
        } else {
          d = margin/(margin+marginafter)*(len-l);
          t = l+d+(marginafter/(margin+marginafter)*(len-l));
        }
        return { d : d, l : l, t : t };
    }
  }
  
  private function unboundedSide(layout : Layout, min : Float, max : Float, fit : Float) : { d : Float, l : Float, t : Float } {
    switch(layout) {
      case Margins(margin, marginafter):
        if(marginafter == null)
          marginafter = margin;
        var content = restrict(fit, min, max);
        return { d : margin, l : content, t : margin+content+marginafter };
      case Center(content):
        if(content == null)
          content = fit;
        content = restrict(content, min, max);
        return { d : 0.0, l : content, t : content };
      case AnchorStart(margin, content):
        if(content == null)
          content = restrict(fit, min, max);
        return { d : margin, l : content, t : margin+content };
      case AnchorEnd(margin, content):
        if(content == null)
          content = restrict(fit, min, max);
        return { d : 0.0, l : content, t : margin+content };
      case Measures(margin, content, marginafter):
        if(content == null)
          content = fit;
        var content = restrict(content, min, max);
        return { d : margin, l : content, t : margin+content+marginafter };
    }
  }
}