package ui.core;

class MultiContainer extends Container {
  private var children : Array<Element>;
  
  private function new() {
    children = new Array();
    super();
  }
  
  public function addChild(c : Element) {
    children.push(c);
    c.parent = this;
  }
  
  public function removeChild(c : Element) : Void {
    var index = getIndex(c);
    if(index < 0) 
      return;
    children.splice(index, 1);    
    c.parent = null;
  }
  
  private function getIndex(el : Element) : Int {
    for(i in 0...children.length)
      if(children[i] == el)
        return i;
    return -1;
  }
  
  public override function render() {
    super.render();
    for(c in children)
      c.render();
  }
}