package ui.flash9;

import ui.core.IView;
import ui.core.Size;
import ui.controls.Button;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.display.GradientType;
import flash.display.SpreadMethod;
import flash.filters.DropShadowFilter;
import flash.filters.BevelFilter;

class ButtonContext extends TextElementContext<Button> {
  public static var style_out = {
    bg : {  angle : -Math.PI/2,
            gradientType : GradientType.LINEAR,
            colors: [0xcceeff, 0x99ccff, 0xcceeff, 0xffffff],
            alphas: [100, 100, 100, 100],
            ratios: [0x00, 0x50, 0x60, 0xdd],
            x: 0.0, y: 0.0,
            spreadMethod : SpreadMethod.PAD },
    border : { color : 0x003366, width : 1, alpha : 1.0 },
    textformat : new TextFormat("Verdana", 11, 0x003366, true, false, false, null, null, "center"),
    filters : [ new DropShadowFilter(1, 45, 0x000000, 0.2, 8, 8),
                new BevelFilter(2, 45, 0xffffff, 0.5, 0x000000, 0.5, 4, 5)],
    padding : { width  : 8, height : 3 },
    corners : { tl : 4, tr : 4, bl : 4, br : 4 }
  };
  
  public static var style_over = {
    bg : {  angle : -Math.PI/2,
            gradientType : GradientType.LINEAR,
            colors: [0xddeeff, 0xaaddff, 0xddeeff, 0xffffff],
            alphas: [100, 100, 100, 100],
            ratios: [0x00, 0x50, 0x60, 0xdd],
            x: 0.0, y: 0.0,
            spreadMethod : SpreadMethod.PAD },
    border : { color : 0x336699, width : 1, alpha : 1.0 },
    textformat : new TextFormat("Verdana", 11, 0x000000, true),
    filters : [ new DropShadowFilter(1, 45, 0x000000, 0.2, 8, 8),
                new BevelFilter(2, 45, 0xffffff, 0.5, 0x000000, 0.5, 4, 5)],
    padding : { width  : 8, height : 3 },
    corners : { tl : 4, tr : 4, bl : 4, br : 4 }
  };
  
  public static var style_click = {
    bg : {  angle : -Math.PI/2,
            gradientType : GradientType.LINEAR,
            colors: [0xffffcc, 0xffcc99, 0xffffcc, 0xffffff],
            alphas: [100, 100, 100, 100],
            ratios: [0x00, 0x50, 0x60, 0xdd],
            x:      0.0, y:      0.0,
            spreadMethod : SpreadMethod.PAD},
    border : { color : 0x666633, width : 1, alpha : 1.0 },
    textformat : new TextFormat("Verdana", 11, 0x996600, true),
    filters : [ new DropShadowFilter(1, 45, 0x000000, 0.2, 8, 8),
                new BevelFilter(2, 45, 0x000000, 0.3, 0xffffff, 0.3, 4, 5)],
    padding : { width  : 8, height : 3 },
    corners : { tl : 4, tr : 4, bl : 4, br : 4 }
  };
  
  public function new(view : IView, el : Button) {
    super(view, el);
    style = style_out;
    textfield.mouseEnabled = false;
    sprite.addEventListener("mouseOver", mouseover);
    sprite.addEventListener("mouseOut", mouseout);
    sprite.addEventListener("mouseDown", mousedown);
    sprite.addEventListener("mouseUp", mouseover);
    sprite.buttonMode = true;
  }
  
  private function mouseover(e) {
    style = style_over;
    el.render();
  }
  
  private function mouseout(e) {
    style = style_out;
    el.render();
  }
  
  private function mousedown(e) {
    style = style_click;
    el.render();
  }
}