package ui.flash9;

import flash.display.Sprite;
import ui.core.Element;
import ui.core.KeyInteraction;
import ui.core.MouseInteraction;
import ui.core.Size;
import ui.core.IContext;
import ui.core.IView;
import ui.core.Rectangle;

class ElementContext<T : Element> implements IContext {
  public var sprite(default, null) : Sprite;
  var g : flash.display.Graphics;
  var el : T;
  public var mouse(default, null) : MouseInteraction;
  public var key(default, null) : KeyInteraction;
  
  public function new(view : IView, el : T) {
    this.el = el;
    sprite = new Sprite();
    if(el.parent == null || el.parent.context == null)
      cast(view, StageView).sprite.addChild(sprite);
    else
      cast(el.parent.context, ElementContext<Dynamic>).sprite.addChild(sprite);
    key = new F9KeyInteraction(sprite, el);
    mouse = new F9MouseInteraction(sprite, el);
  }
  
  public override function render(r : Rectangle<Float>) {
    draw(r);
    place(r);
  }
  
  private function draw(r : Size<Float>) { }  
  
  private function place(r : Rectangle<Float>) {
    sprite.x = Math.floor(r.x);
    sprite.y = Math.floor(r.y);
  }
  
  public function fitSize() {
    return { width : 0.0, height : 0.0 };
  }
}