package ui.flash9;

import ui.core.Element;
import ui.core.MouseInteraction;
import flash.display.Sprite;
import flash.events.MouseEvent;

class F9MouseInteraction extends MouseInteraction {
  var el : Element;
  
	public function new(sprite : Sprite, el : Element) {
    super();
    this.el = el;
    var self = this;    
		sprite.addEventListener(MouseEvent.CLICK, function(e:MouseEvent) {
      self.click.dispatchEvent(self.getMouseEvent(e));
    });
    sprite.addEventListener(MouseEvent.MOUSE_DOWN, function(e:MouseEvent) {
      self.down.dispatchEvent(self.getMouseEvent(e));
    });
    sprite.addEventListener(MouseEvent.MOUSE_UP, function(e:MouseEvent) {
      self.up.dispatchEvent(self.getMouseEvent(e));
    });
    sprite.addEventListener(MouseEvent.MOUSE_MOVE, function(e:MouseEvent) {
      self.move.dispatchEvent(self.getMouseEvent(e));
    });
    sprite.addEventListener(MouseEvent.MOUSE_OVER, function(e:MouseEvent) {
      self.enter.dispatchEvent(self.getMouseEvent(e));
    });
    sprite.addEventListener(MouseEvent.MOUSE_OUT, function(e:MouseEvent) {
      self.leave.dispatchEvent(self.getMouseEvent(e));
    });
	}
  
  private function getMouseEvent(e:MouseEvent){
    return {  target : el,
              buttonDown : e.buttonDown,
              ctrlKey : e.ctrlKey,
              shiftKey : e.shiftKey,
              local: { x : e.localX, y : e.localY },
              view: { x : e.stageY, y : e.stageY } }
  }
}