package ui.flash9;

import ui.core.IView;
import ui.core.Size;
import ui.controls.TextBox;
import flash.display.GradientType;
import flash.display.SpreadMethod;
import flash.text.TextFormat;
import flash.filters.DropShadowFilter;
import flash.filters.BevelFilter;

class TextBoxContext extends TextElementContext<TextBox> {  
  public static var style_input = {
    bg : {
      angle : -Math.PI/2,
      gradientType : GradientType.LINEAR,
      colors: [0xffffcc, 0xffffff],
      alphas: [100, 100],
      ratios: [0x00, 0xdd],
      x:      0.0, y:      0.0,
      spreadMethod : SpreadMethod.PAD
    },
    border: { color : 0x666633, width : 1, alpha : 1.0 },
    textformat : new TextFormat("Verdana", 11, 0x000000, true),
    filters : [ new DropShadowFilter(1, 45, 0x000000, 0.2, 8, 8),
                new BevelFilter(2, 45, 0x000000, 0.5, 0xffffff, 0.5, 4, 5)],
    padding : { width  : 3, height : 2 },
    corners : null
  };
  
  public static var style_away = {
    bg : {
      angle : -Math.PI/2,
      gradientType : GradientType.LINEAR,
      colors: [0xcceeff, 0xffffff],
      alphas: [100, 100],
      ratios: [0x00, 0xdd],
      x:      0.0, y:      0.0,
      spreadMethod : SpreadMethod.PAD
    },
    border: { color : 0x003366, width : 1, alpha : 1.0 },
    textformat : new TextFormat("Verdana", 11, 0x003366, true),
    filters : [ new DropShadowFilter(1, 45, 0x000000, 0.2, 8, 8),
                new BevelFilter(2, 45, 0x000000, 0.5, 0xffffff, 0.5, 4, 5)],
    padding : { width  : 3, height : 2 },
    corners : null
  };
  
  public function new(view : IView, el : TextBox) {
    super(view, el);
    style = style_away;
    textfield.type = flash.text.TextFieldType.INPUT;
    textfield.addEventListener("change", change);
    textfield.addEventListener("focusIn", focusIn);
    textfield.addEventListener("focusOut", focusOut);
    sprite.addEventListener("mouseDown", focusIn);  
  }
  
  private function focusOut(e) {
    style = style_away;
    textfield.setSelection(0, 0);
    el.render();
  }
  
  private function change(e) {
    el.text = textfield.text;
  }
  
  private function focusIn(e) {
    style = style_input;
    sprite.stage.focus = textfield;
    el.render();
  }
  
	private override function draw(r : Size<Float>) {
    super.draw(r);
    if(sprite.stage.focus == textfield && textfield.selectionBeginIndex > 0) {
      // dirty hack to position the carrect correctly in the visible area
      textfield.setSelection(textfield.selectionBeginIndex-1, textfield.selectionEndIndex);
      textfield.setSelection(textfield.selectionBeginIndex+1, textfield.selectionEndIndex);
    }
  }
}